//<html><pre>
/* --------------------------------------------------------------------------------------------------------
	z1.java 	Z1														ver. 1.00 (JDK 1.02)
																		ueyama@infonet.co.jp 2009.03.14
-------------------------------------------------------------------------------------------------------- */
import java.applet.*;
import java.awt.*;


public class z1 extends Applet
{
	int			P1=1, P2=3;												// s̏ʒu
	int			Px1=92, Py1=54, Px2=129, Py2=54;						// s̕\W
	int			Ax=53, Ay=36;											// Fixed plate (a) ̕\W
	int			B=0, Bx= 84, By= 5;										// Control plate (b) ̏Ԃƕ\W
	int			C=1, Cx=121, Cy= 5;										// Control plate (c) ̏Ԃƕ\W
	int			D=1, Dx=  5, Dy=46;										// Impluse plate (d) ̏Ԃƕ\W
	int			E=1, Ex= 80, Ey=46;										// Intermediate plate (e) ̏Ԃƕ\W
	int			F=1, Fx=120, Fy=46;										// Results plate (f) ̏Ԃƕ\W
	int			Yd[]={0,140,216,278};									// ei̕\YW̍
	int			Lx[]={5,15,62,100,137,175,216,226};						// ⏕W
	int			Ly[]={62,146,156,201,277,339};							// ⏕W
	Image		Img;

	public void init()													// ݒ
	{
		String bg=getParameter("bgcolor");
		int bgc=Integer.valueOf(bg,16).intValue();
		setBackground(new Color(bgc)); 
		MediaTracker mt=new MediaTracker(this);
		Img=getImage(getCodeBase(), getParameter("figure"));
		mt.addImage(Img, 0);
		try
		{
			mt.waitForID(0);
		}
		catch(InterruptedException e){};
	}
	
	public boolean inside(int x, int a, int b)							// }EẌʒuW`FbN
	{
		return (x<=Math.max(a,b) && x>=Math.min(a,b)) ? true:false;
	}

	public void dsp_g(int x, int y, int m, int n, int e, int c)			// 摜̕\
	{
		int			w=0, h=0, ox=0, oy=0;
		Graphics	gx=getGraphics();
		switch(c)
		{
			case  0: w= 131; h= 52; ox=   0; oy=  0; break;				// Fixed plate (a)
			case  1: w=  32; h= 87; ox= 131; oy=  0; break;				// Control plate (b)
			case  2: w=  32; h= 87; ox= 163; oy=  0; break;				// Control plate (c)
			case  3: w= 112; h= 32; ox= 195; oy=  0; break;				// Impluse plate (d)
			case  4: w=  77; h= 32; ox= 307; oy=  0; break;				// Intermediate plate (e)
			case  5: w=  97; h= 32; ox= 384; oy=  0; break;				// Results plate (f)
			case  6: w=   6; h=  6; ox= 425; oy= 34; break;				// Pin
			case  7: w=  69; h= 52; ox=  31; oy= 52; break;				// Fixed Pin (4)
			case  8: w= 218; h= 49; ox= 195; oy= 34; break;				// Cross-section
			case  9: w= 112; h=  2; ox= 195; oy= 32; break;				// Cross-section (d)
			case 10: w=  77; h=  2; ox= 307; oy= 32; break;				// Cross-section (e)
			case 11: w=  97; h=  2; ox= 384; oy= 32; break;				// Cross-section (f)
			case 12: w=   6; h= 28; ox= 413; oy= 34; break;				// Cross-section (Pin)
		}
		gx.clipRect(x, y, w, h);
		if(e>0) gx.clearRect(x, y, w, h);
		gx.drawImage(Img,x-(ox+m*w),y-(oy+n*h),this);
		gx.dispose();
	}
	
	public void dsp_plate(int n)										// Plate ̕\
	{
		dsp_g(Dx+D*10, Dy+n*Yd[2], 0, 0, 0, 3);							// Impluse plate (d)
		dsp_g(Fx+F*10, Fy+n*Yd[2], 0, 0, 0, 5);							// Results plate (f)
		dsp_g(Ex+E*10, Ey+n*Yd[3], 0, 0, 0, 4);							// Intermediate plate (e)
		dsp_g(Bx, By+B*10+n*Yd[1], 0, 0, 0, 1);							// Control plate (b)
		dsp_g(Cx, Cy+C*10+n*Yd[1], 0, 0, 0, 2);							// Control plate (c)
		dsp_g(Ax, Ay+n*Yd[2], 0, n, 0, 0);								// Fixed plate (a)
		dsp_g(Dx+D*10, 401, 0, 0, 0, 9);								// Impluse plate (d)
		dsp_g(Fx+F*10, 401, 0, 0, 0, 11);								// Results plate (f)
		dsp_g(Ex+E*10, 397, 0, 0, 0, 10);								// Intermediate plate (e)
		dsp_g(Ex+E*10, 405, 0, 0, 0, 10);								// Intermediate plate (e)
	}

	public void clr_plate(int x, int y, int c)							// Plate ̏
	{
		int			w=0, h=0;
		Graphics	gx=getGraphics();
		switch(c)
		{
			case  0: w= 131; h= 52; break;								// Fixed plate (a)
			case  1: w=  32; h= 87; break;								// Control plate (b, c)
			case  2: w= 112; h= 32; break;								// Impluse plate (d)
			case  3: w=  77; h= 32; break;								// Intermediate plate (e)
			case  4: w=  97; h= 32; break;								// Results plate (f)
			case  5: w= 112; h=  2; break;								// Impluse plate (d)
			case  6: w=  77; h=  2; break;								// Intermediate plate (e)
			case  7: w=  97; h=  2; break;								// Results plate (f)
		}
		gx.clearRect(x, y, w, h);
		gx.dispose();
	}
	
	public void dsp_pin()												// Pin ̕\
	{
		dsp_g(Bx, Ay+Yd[1], 0, 0, 0, 7);								// Fixed Pin  ̕\
		dsp_g(Bx, Ay+Yd[3], 0, 0, 0, 7);								// Fixed Pin  ̕\
		for(int i=0; i<4; i++)											// Floating pin ̕\
		{
			dsp_g(Px1+10*(P1%2), Py1+10*(P1/2)+Yd[i], 0, 0, 0, 6);
			dsp_g(Px2+10*(P2%2), Py2+10*(P2/2)+Yd[i], 0, 0, 0, 6);
		}
		dsp_g(Px1+10*(P1%2), 388, 0, 0, 0, 12);							// fʐ} pin ̕\
		dsp_g(Px2+10*(P2%2), 388, 0, 0, 0, 12);
	}
	
	public void dsp_line()												// ⏕̕\
	{
		int i;
		Graphics gx=getGraphics();
		gx.setColor(new Color(0xe0e0ff));
		for(i=0;i<8;i++) gx.drawLine(Lx[i],0,Lx[i],372);
		for(i=0;i<6;i++) gx.drawLine(0,Ly[i],232,Ly[i]);
		gx.dispose();
	}
	
	public void paint(Graphics g)										// ʂ̕\
	{
		g.clearRect(0, 0, size().width, size().height);
		dsp_line();														// ⏕̕\
		dsp_plate(0);													// Plate (g) ̕\
		dsp_plate(1);													// Plate (o) ̕\
		dsp_pin();														// Pin ̕\
		dsp_g(9, 377, 0, 0, 0, 8);										// Cross-section
	}
	
	public boolean mouseDown(Event e, int mx, int my)					// }EXNbNꂽƂ̏
	{
		int i, m=0;
		int by=By+B*10+Yd[1], cy=Cy+C*10+Yd[1], dx=Dx+D*10;
		int b=By+B*10, c=Cy+C*10;
		if(inside(mx,dx,dx+112) && inside(my,Dy+Yd[2],Dy+Yd[2]+32)) m=3;				// Plate D
		if(inside(mx,dx,dx+112) && inside(my,Dy,Dy+32)) m=3;							// Plate D
		if(inside(mx,Bx,Bx+32) && inside(my,by,by+87) && !(P1==3 && B==1 && D==0)) m=1;	// Plate B
		if(inside(mx,Bx,Bx+32) && inside(my,b,b+87) && !(P1==3 && B==1 && D==0)) m=1;	// Plate B
		if(inside(mx,Cx,Cx+32) && inside(my,cy,cy+87) && !(P2==1 && C==0 && E==0)) m=2;	// Plate C
		if(inside(mx,Cx,Cx+32) && inside(my,c,c+87) && !(P2==1 && C==0 && E==0)) m=2;	// Plate C
		if(m>0)
		{
			for(i=0; i<4; i++)
			{
				dsp_g(Px1+10*(P1%2), Py1+10*(P1/2)+Yd[i], 0, 1, 1, 6);	// Floating pin 1 ̏
				dsp_g(Px2+10*(P2%2), Py2+10*(P2/2)+Yd[i], 0, 1, 1, 6);	// Floating pin 2 ̏
			}
			dsp_g(Px1+10*(P1%2), 388, 1, 0, 1, 12);
			dsp_g(Px2+10*(P2%2), 388, 1, 0, 1, 12);
			switch(m)
			{
			case 1: clr_plate(Bx, By+B*10, 1);							// Control plate (b) ̏
					clr_plate(Bx, By+B*10+Yd[1], 1);					// Control plate (b) ̏
					B=(B==0)?1:0;
					P1=D+B*2;
					break;
			case 2: clr_plate(Cx, Cy+C*10, 1);							// Control plate (c) ̏
					clr_plate(Cx, Cy+C*10+Yd[1], 1);					// Control plate (c) ̏
					C=(C==0)?1:0;
					P2=E+C*2;
					break;
			case 3: clr_plate(Dx+D*10, Dy, 2);							// Control plate (d) ̏
					clr_plate(Dx+D*10, Dy+Yd[2], 2);					// Control plate (d) ̏
					clr_plate(Dx+D*10, 401, 5);							// Impluse plate (d)
					D=(D==0)?1:0;
					if(P1<3)
					{
						P1=D+B*2;
						clr_plate(Ex+E*10, Ey, 3);						// Intermediate plate (e)
						clr_plate(Ex+E*10, Ey+Yd[3], 3);				// Intermediate plate (e)
						clr_plate(Ex+E*10, 397, 6);						// Intermediate plate (e)
						clr_plate(Ex+E*10, 405, 6);						// Intermediate plate (e)
						E=P1%2;
						if(P2>1 || (B+C+P2==0 && P1==1))
						{
							clr_plate(Fx+F*10, Fy, 4);					// Results plate (f)
							clr_plate(Fx+F*10, Fy+Yd[2], 4);			// Results plate (f)
							clr_plate(Fx+F*10, 401, 7);					// Results plate (f)
							P2=E+C*2;
							F=P2%2;
						}
					}
			}
			dsp_line();													// ⏕̕\
			dsp_plate(0);												// Plate (g) ̕\
			dsp_plate(1);												// Plate (o) ̕\
			dsp_pin();
//			showStatus("B="+B+",  C="+C+",  D="+D+",  E="+E+",  F="+F+",  P1="+P1+",  P2="+P2);
		}
		return true;
	}
	
	public boolean mouseUp(Event e, int mx, int my)						// }EXNbNꂽƂ̏
	{
		return true;
	}
}
//</pre><a HREF="JavaScript:history.go(-1)">߂</a></html>
